/* Crude chmem - compile with gcc */
/* (C) 1997 Chad Page */

#include <unistd.h>
#include "/usr/bcc/include/a.out.h"
#include <fcntl.h>

void main(argc, argv)
int argc;
char **argv;
{
	int fd;
	unsigned int nchmem, text, data, bss, total, rtotal;
	struct exec ex;

	if (argc < 3) {
		printf("chmem: file new_chmem\n");
		return;
	}

	if ((fd = open(argv[1], O_RDWR)) == -1) {
		printf("File not found...\n");
		return;
	}
	
	read(fd, &ex, sizeof(struct exec));
	if ((ex.a_magic[0] != A_MAGIC0) || (ex.a_magic[1] != A_MAGIC1)) {
 		printf("Invalid executalbe\n");
		return;
	}

	nchmem = atoi(argv[2]);
	text = ex.a_text; data = ex.a_data; bss = ex.a_bss; 
	total = data+bss;
	rtotal = ex.a_total;
	printf("old chmem=%u data+bss size=%u new chmem=%u\n", total, rtotal, nchmem); 

	total = nchmem;
	ex.a_total = total;

	write(fd, &ex, sizeof(struct exec));
}
